"""
Catalog management
"""

import string, pdb

def catalogedIn(self, catalog):
    """
    Am I cataloged in a given catalog?
    """
    return catalog._catalog.uids.has_key(self.url())
	
manageCatalog_request_letter = """
%(username)s requests that an object be cataloged.

View it:
  %(url)s
  
Catalog it
  %(url)s/manageCatalogForm
  
Make sure to be logged in as superuser to
perform catalog entry adding.
"""

def manageCatalog(self, submit, REQUEST):
    """
    Change catalog entry for an object.
    """
    path=self.url()
    catalog=self.SiteIndex
    user=REQUEST.AUTHENTICATED_USER
    if not (user.has_role('Owner', self) or
	    user.has_role('Manager', self) or
	    user.has_role('Reviewer', self)):
	return self.manageCatalogForm(self, REQUEST,
	       manage_tabs_message='Cannot change catalog entry. You must be the Owner of this object.')
    if submit==' Add Entry ':
	if user.has_role('Contributor', self) or \
	   user.has_role('Reviewer', self) or \
	   user.has_role('Manager', self):
	    self.unindex_object(self, 'UnreviewedIndex')
	    self.index_object(self, 'SiteIndex')
	    if not user.has_role('Owner', self):
		try: notify_cataloged(self, REQUEST)
		except: pass
    elif submit==' Update Entry ':
	if user.has_role('Contributor', self) or catalog._catalog.uids.has_key(path):
	    self.index_object(self)
    elif submit==' Remove Entry ':
	if user.has_role('Contributor', self) or catalog._catalog.uids.has_key(path):
	    self.unindex_object(self)
    elif submit==' Request Entry ':
	self.index_object(self, 'UnreviewedIndex')
	self.Utilities.mail_reviewers(self, REQUEST,
	    subject="Catalog Request",
	    body=manageCatalog_request_letter % {
		'fullname': user.full_name,
		'email': user.email,
		'username': user.getUserName(),
		'url': self.absolute_url()
		}
	    )
	
	return self.manageCatalogForm(self, REQUEST, manage_tabs_message='Your request has been submitted.')
			
    return self.manageCatalogForm(self, REQUEST, manage_tabs_message='Catalog entry changed.')
	
	
def notify_cataloged(self, REQUEST):
    message = """\
From: "%(manager)s" <%(manageremail)s>
To: "%(user)s" <%(useremail)s>
Subject: [Zope Site] Object cataloged

%(manager)s has cataloged your object at:
%(url)s
"""
    dict = { 'manager':REQUEST.AUTHENTICATED_USER.full_name,
             'manageremail':REQUEST.AUTHENTICATED_USER.email,
             'user': self.acl_users.getUser(self.creator()).full_name,
	     'useremail': self.acl_users.getUser(self.creator()).email,
	     'url': self.absolute_url()
    }
    self.MailHost.send(message % dict)
