import sys, os, string, time, random, urllib
from DateTime import DateTime



def sort_key(self):
    if hasattr(self.aq_parent.aq_base, 'sort_key_'):
        return str(self.sort_key_)
    return self.id

def addProject(self, id, title='', REQUEST=None):
    """ """
    dest=self.Destination()
    ob=self.Project(id)
    ob.id=id
    ob.title=title
    dest._setObject(id, ob)
    ob=getattr(dest, id)
    k=0
    for n in ('Inception','Elaboration','Construction','Transition'):
        p=ob.Phase(n)
        p.id=n
        p.sort_key_=k
        k=k+1
        ob._setObject(n, p)
        p=getattr(ob, n)
        addIteration(p, 'Iteration_1')

    ob.Inception.status='Active'
    ob.Inception.Iteration_1.status='Active'

#    date=DateTime()
#    ds=REQUEST.get('date_override','')
#    if ds: date=DateTime(ds)
#    else:  date=DateTime()
#    REQUEST['date']=date
#    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
#    ob.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')


def addIteration(self, id, title='', REQUEST=None):
    """ """
    
    ob=self.Iteration(id)
    ob.id=id
    ob.title=title
    self._setObject(id, ob)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')


def addTask(self, id, title='', REQUEST=None):
    """ """
    ob=self.Task(id)
    ob.id=id
    ob.title=title
    self._setObject(id, ob)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')






# Findable object methods. These are methods common to objects
# which subclass Findable, which provide implementations for
# obtaining certain metadata (such as creator), as well as
# common methods that handle the details of indexing and
# unindexing Findable objects.


def onDeleteObject(self):
    """Object delete handler."""
    self.unindex_object()


def creator(self):
    """Return a sequence of user names who have the local
       Owner role on an object. The name creator is used
       for this method to conform to Dublin Core."""
    parent=self.aq_parent
    roles=parent.aq_acquire('__ac_local_roles__')
    dict=roles or {} #parent.__ac_local_roles__ or {}
    items=[]
    for key, val in dict.items():
        if 'Owner' in val:
            items.append(key)
    return string.join(items, ', ')



def url(self, ftype=urllib.splittype, fhost=urllib.splithost):
    """Return a SCRIPT_NAME-based url for an object."""
    if hasattr(self, 'DestinationURL') and \
       callable(self.DestinationURL):
        url='%s/%s' % (self.DestinationURL(), self.id)
    else: url=self.absolute_url()
    type, uri=ftype(url)
    host, uri=fhost(uri)
    script_name=self.REQUEST['SCRIPT_NAME']
    __traceback_info__=(`uri`, `script_name`)
    if script_name:
        uri=filter(None, string.split(uri, script_name))[0]
    uri=uri or '/'
    if uri[0]=='/': uri=uri[1:]
    return uri

def summary(self, num=200):
    """Return a summary of the text content of the object."""
    if not hasattr(self, 'text_content'):
        return ''
    attr=getattr(self, 'text_content')
    if callable(attr):
        text=attr()
    else: text=attr
    n=min(num, len(text))
    return text[:n]

def index_object(self):
    """A common method to allow Findables to index themselves."""
    self.SiteIndex.indexObject(self)

def unindex_object(self):
    """A common method to allow Findables to unindex themselves."""
    self.SiteIndex.unindexObject(self)




# STX Document methods
# ---------------------


default_format="""<!--#var standard_html_header-->

<!--#var content fmt="structured-text"-->

<!--#var standard_html_footer-->"""

def addSTXDocument(self, id, title='', submit='', REQUEST={}):
    """ """
    dest=self.Destination()
    ob=self.STXDocument(default_format, __name__=id)
    ob.title=title
    dest._setObject(id, ob)
    ob=getattr(dest, id)
    date=DateTime()
    ds=REQUEST.get('date_override','')
    if ds: date=DateTime(ds)
    else:  date=DateTime()
    REQUEST['date']=date
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.propertysheets.Basic.manage_changeProperties(REQUEST)
    ob.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')
    

def STXDocument_text_content(self):
    """Return the text content of the object."""
    # return the actual stx content...
    return self.content

def STXDocument_onEditBegin(self):
    """ """
    self.SiteIndex.unindexObject(self)

def STXDocument_onEditComplete(self):
    """ """
    self.SiteIndex.indexObject(self)


# HTML Document methods
# ---------------------


def addHTMLDocument(self, id, title='', file='', submit='', REQUEST={}):
    """ """
    dest=self.Destination()
    ob=self.HTMLDocument(file, __name__=id)
    ob.title=title
    dest._setObject(id, ob)
    ob=getattr(dest, id)
    date=DateTime()
    ds=REQUEST.get('date_override','')
    if ds: date=DateTime(ds)
    else:  date=DateTime()
    REQUEST['date']=date
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')

def HTMLDocument_text_content(self):
    """Return the text content of the object."""
    # could try to __call__ ourselves here, but its probably
    # better not to, since the text of the object should be
    # the most relevant and stuff common to site pages should
    # be include using var tags...
    return self.read()


def HTMLDocument_onEditBegin(self):
    """ """
    self.SiteIndex.unindexObject(self)

def HTMLDocument_onEditComplete(self):
    """ """
    self.SiteIndex.indexObject(self)


# NewsItem methods
# ----------------

def NewsItem_text_content(self):
    """Return the text content of the object."""
    return self.text


def approveNewsItem(self, approve=0, REQUEST=None):
    """ """
    for ps in self.propertysheets.values():
        ps.manage_changeProperties(REQUEST=REQUEST)
    if approve:
        self.index_object()
    # Add to catalog here...
    
    self.title=title



def findAllMemberNames(self):
    """ """
    # XXX This should go up the folder tree...
    allusers=self.acl_users.getUsers()
    names=[]
    for user in allusers:
        if user.has_role('Member'):
            names.append(user.getUserName())
    return names



def foo(self):
    t = []
    obj = self
    count = 0
    while 1:
        if hasattr(obj, 'aq_parent'):
            t.append(`obj`)
            obj = obj.aq_parent
        else:
            break
        count = count + 1
        if count > 10:
            t.append("!!")
            break
    return "<h3>Self gots .%s.</h3>" % string.join(t, ', ')

def getOwners(self, join=string.join):
    parent = self.aq_parent             # XXX Workaround
    parent.aq_acquire('__ac_local_roles__')
    dict = parent.__ac_local_roles__ or {} # XXX Workaround
    list=[]
    for key, val in dict.items():
        if 'Owner' in val:
            list.append(key)
    return join(list, ', ')




def aq_base(ob):
    if hasattr(ob,  'aq_base'):
        return ob.aq_base
    return ob

def reindex_all(self, obj=None):
    """ """
    if obj is None: obj=self
    if hasattr(aq_base(obj), 'index_object'):
        obj.index_object()
    if hasattr(aq_base(obj), 'objectValues'):
        sub=obj.objectValues()
        for item in obj.objectValues():
            reindex_all(self, item)
    return 'done!'
               
    
