import sys, os, string, time, random, urllib
from DateTime.DateTime import DateTime


def gen_class_id(self):
    import md5, base64, time
    id=md5.new()
    id.update(self.absolute_url())
    id.update(str(time.time()))
    id=id.digest()
    id=string.strip(base64.encodestring(id))
    return '*'+id


def sort_key(self):
    if hasattr(self.aq_parent.aq_base, 'sort_key_'):
        return str(self.sort_key_)
    return self.id


def getValidUserNames(self):
    """ """
    # XXX This should go up the folder tree...
    allusers=self.acl_users.getUsers()
    names=[]
    for user in allusers:
        if user.has_role('Member'):
            names.append(user.getUserName())
    return names

def assignedTo(self):
    return ['brian']



def index_object(self):
    """ """
    try:
        if self.project_type=='Community':
            self.SiteIndex.catalog_object(self, self.url())
    except: pass

def unindex_object(self):
    """ """
    try:
        if self.project_type=='Community':
            self.SiteIndex.uncatlog_object(self.url())
    except: pass


def nid(self):
    """ """
    return self._p_oid


def getArtifacts(self, subs=0, obs=None):
    if obs is None: obs=[]
    for ob in self.objectValues(['Generic Artifact','File']):
        obs.append(ob)
    if subs:
        for ob in self.objectValues(['Project','Phase','Iteration']):
            obs=ob.getArtifacts(subs=1, obs=obs)
    return obs


def status_change(self, status, req={}, zero=DateTime('1/1/1970')):
    sd, fd=self.act_start_date, self.act_finish_date
    date=DateTime()
    if status==self.status: return
    elif status=='Pending':
        req['act_start_date']=zero
        req['act_finish_date']=zero
    elif status=='Active':
        if sd == zero: req['act_start_date']=date
        if fd != zero: req['act_finish_date']=zero
    elif status=='Completed':
        if sd == zero: req['act_start_date']=date
        if fd == zero: req['act_finish_date']=date



def addProject(self, id, title, project_type,
               est_start_date, est_finish_date,
               est_effort, est_value, status,
               abstract, customer='',
               REQUEST={}):
    """ """
    # Projects are created in Project Libraries, so self in
    # this case is the Project factory, which is contained
    # in the ProjectLibrary ZClass -self.aq_parent.aq_parent
    # is the Project Library instance where we are creating
    # the new Project.
    dest=self.aq_parent.aq_parent
    ob=self.Project(id)
    ob.id=id
    ob.title=title
    dest._setObject(id, ob)
    ob=getattr(dest, id)
    k=0
    for n in ('Inception','Elaboration','Construction','Transition'):
        p=ob.Phase(n)
        p.id=n
        p.sort_key_=k
        k=k+1
        ob._setObject(n, p)
        p=getattr(ob, n)
        addIteration(p, 'Iteration_1')

    REQUEST['date']=DateTime()
    status_change(ob, status, REQUEST)
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.propertysheets.ProjectProperties.manage_changeProperties(REQUEST)
    ob.propertysheets.TrackableProperties.manage_changeProperties(REQUEST)
    ob.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL2']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')


def editProject(self, title, project_type,
               est_start_date, est_finish_date,
               est_effort, est_value, status,
               abstract, customer='',
               REQUEST={}):
    """ """
    self.unindex_object()
    status_change(self, status, REQUEST)
    self.propertysheets.ProjectProperties.manage_changeProperties(REQUEST)
    self.propertysheets.TrackableProperties.manage_changeProperties(REQUEST)
    self.propertysheets.Findables.manage_changeProperties(REQUEST)
    self.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')




def addIteration(self, id, title='', REQUEST=None):
    """ """
    ob=self.Iteration(id)
    ob.id=id
    ob.title=title
    self._setObject(id, ob)
    ob=getattr(self, id)
    ob.date=DateTime()
    ob.propertysheets.TrackableProperties.manage_changeProperties(REQUEST)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL2']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')


def editIteration(self, title, 
                  est_start_date, est_finish_date,
                  est_effort, act_effort, status,
                  REQUEST={}):
    """ """
    self.title=title
    status_change(self, status, REQUEST)
    self.propertysheets.TrackableProperties.manage_changeProperties(REQUEST)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')





def addTask(self, id, title, priority, assigned_to, est_start_date,
            est_finish_date, est_effort, status, desc,
            REQUEST={}):
    """ """
    ob=self.Task(id)
    ob.id=id
    self._setObject(id, ob)
    ob=getattr(self, id)
    REQUEST['date']=DateTime()
    status_change(self, status, REQUEST)
    ob.propertysheets.TaskProperties.manage_changeProperties(REQUEST)
    ob.propertysheets.TrackableProperties.manage_changeProperties(REQUEST)
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL2']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')


def editTask(self, title, priority, assigned_to, est_start_date,
             est_finish_date, est_effort, status, desc,
             REQUEST={}):
    """ """
    self.unindex_object()
    status_change(self, status, REQUEST)
    self.propertysheets.TaskProperties.manage_changeProperties(REQUEST)
    self.propertysheets.TrackableProperties.manage_changeProperties(REQUEST)
    self.propertysheets.Findables.manage_changeProperties(REQUEST)
    self.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')





default_format="""<!--#var standard_html_header-->

<!--#if "format=='Structured Text'"-->
<!--#var content fmt="structured-text"-->
<!--#elif "format=='Plain Text'"-->
<pre><!--#var content--></pre>
<!--#else-->
<!--#var content-->
<!--#/if-->

<!--#var standard_html_footer-->"""

def addGenericArtifact(self, id, title, format, content='',
                       submit='', REQUEST={}):
    """ """
    ob=self.GenericArtifact(default_format, __name__=id)
    ob.id=id
    ob.title=title
    self._setObject(id, ob)
    ob=getattr(self, id)
    REQUEST['date']=DateTime()
    ob.propertysheets.Basic.manage_changeProperties(REQUEST)
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.index_object()
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL2']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')





def onDeleteObject(self):
    """Object delete handler."""
    self.unindex_object()


def findAllMemberNames(self):
    """ """
    # XXX This should go up the folder tree...
    allusers=self.acl_users.getUsers()
    names=[]
    for user in allusers:
        if user.has_role('Member'):
            names.append(user.getUserName())
    return names


def getOwners(self, join=string.join):
    parent = self.aq_parent             # XXX Workaround
    parent.aq_acquire('__ac_local_roles__')
    dict = parent.__ac_local_roles__ or {} # XXX Workaround
    list=[]
    for key, val in dict.items():
        if 'Owner' in val:
            list.append(key)
    return join(list, ', ')




def aq_base(ob):
    if hasattr(ob,  'aq_base'):
        return ob.aq_base
    return ob
