import sys, os, string, time, random, urllib
from DateTime import DateTime

import pdb


# Findable object methods. These are methods common to objects
# which subclass Findable, which provide implementations for
# obtaining certain metadata (such as creator), as well as
# common methods that handle the details of indexing and
# unindexing Findable objects.


def manage_afterAdd(self, item, container):
    self.index_object(self)
    for object in self.objectValues():
        try: s=object._p_changed
        except: s=0
        object.manage_afterAdd(item, container)
        if s is None: object._p_deactivate()

def manage_afterClone(self, item):
    self.index_object(self)
    for object in self.objectValues():
        try: s=object._p_changed
        except: s=0
        object.manage_afterClone(item)
        if s is None: object._p_deactivate()

def manage_beforeDelete(self, item, container):
    self.unindex_object(self)
    for object in self.objectValues():
        try: s=object._p_changed
        except: s=0
        object.manage_beforeDelete(item, container)
        if s is None: object._p_deactivate()



def creator(self):
    """Return a sequence of user names who have the local
       Owner role on an object. The name creator is used
       for this method to conform to Dublin Core."""
    #parent=self.aq_parent
    #roles=parent.aq_acquire('__ac_local_roles__')
    #dict=roles or {} #parent.__ac_local_roles__ or {}
    #items=[]
    #for key, val in dict.items():
    #    if 'Owner' in val:
    #        items.append(key)
    #return string.join(items, ', ')

    users=[]
    for user, roles in self.get_local_roles():
        if 'Owner' in roles:
            users.append(user)
    return string.join(users, ', ')

def url(self, ftype=urllib.splittype, fhost=urllib.splithost):
    """Return a SCRIPT_NAME-based url for an object."""
    if hasattr(self, 'DestinationURL') and \
       callable(self.DestinationURL):
        url='%s/%s' % (self.DestinationURL(), self.id)
    else: url=self.absolute_url()
    type, uri=ftype(url)
    host, uri=fhost(uri)
    script_name=self.REQUEST['SCRIPT_NAME']
    if script_name:
        uri=filter(None, string.split(uri, script_name))[0]
    uri=uri or '/'
    if uri[0]=='/': uri=uri[1:]
    return uri

def summary(self, num=200):
    """Return a summary of the text content of the object."""
    if not hasattr(self, 'text_content'):
        return ''
    attr=getattr(self, 'text_content')
    if callable(attr):
        text=attr()
    else: text=attr
    n=min(num, len(text))
    return text[:n]

def getIndex(self, REQUEST=None):
    # return the index to index an object in.
    # this is used to index Members's objects in a different
    # index than Contributors's objects.
    if REQUEST is None:
        REQUEST=self.REQUEST        
    if REQUEST.AUTHENTICATED_USER.has_role('Contributor'):
        return self.SiteIndex
    return self.UnreviewedIndex  

def in_catalogs(self):
    """What catalogs am I REALLY in?"""
    catalogs = getattr(self, 'SiteCatalogs', ['SiteIndex', 'UnreviewedIndex'])
    catalogs = map(lambda x, self=self: getattr(self, x), catalogs)
    catalogs = filter(lambda x, self=self: x._catalog.uids.has_key(self.url()), catalogs)
    return map(lambda x: x.id, catalogs)

def index_object(self, catalog=None):
    """
    Update all catalogs I belong to.  If passed a path in Catalog, also add
    self to that catalog.
    """

    # Get the list of catalogs I already belong to
    catalogs = self.in_catalogs()

    # Refresh my entry in each of these catalogs
    for path in catalogs:
	try:
	    catobj = resolve_path(self, path)
	    catobj.uncatalog_object(self.absolute_url(1))
	    catobj.catalog_object(self, self.absolute_url(1))
	except:
	    pass

    # Did I get passed a new path?
    if catalog is not None and catalog not in catalogs:
	catobj = resolve_path(self, catalog)
	try:
	    catobj.uncatalog_object(self.absolute_url(1))
	except: pass
	catobj.catalog_object(self, self.absolute_url(1))

def unindex_object(self, catalog=None):
    """
    Remove self from the path passed in catalog.  If catalog is not given,
    remove self from all catalogs.
    """

    if catalog is not None:
	catobj = resolve_path(self, catalog)
	try:
	    catobj.uncatalog_object(self.absolute_url(1))
	except: pass
	return
    
    catalogs = self.in_catalogs()
    for catalog in catalogs:
	catobj = resolve_path(self, catalog)
	try:
	    catobj.uncatalog_object(self.absolute_url(1))
	except: pass

def date(self):
    """
    Modification date.
    """
    return self.bobobase_modification_time()

# Utility functions
# -----------------

def resolve_path(obj, path):
    while hasattr(obj, 'aq_parent'):
	obj = obj.aq_parent
	if hasattr(obj, 'aq_base'):
	    b = obj.aq_base
	else:
	    b = obj
	if hasattr(b, 'isTopLevelPrincipiaApplicationObject') and \
	   b.isTopLevelPrincipiaApplicationObject:
	    break

    try:
	for id in string.split(path, '/'):
	    try:
		obj=getattr(obj, id)
	    except:
		obj=obj[id]
	return obj
    except:
	raise 'Catalog error', 'Can\'t resolve path: ' + `path`

def fix_catalog_items(self, REQUEST):
    """self should be a catalog"""
    url = self.absolute_url(1)
    write = REQUEST.RESPONSE.write
    buf = ''

    for item in self.searchResults():
	try:
	    obj = self.getobject(item.data_record_id_, REQUEST)
	    catalogs = getattr(obj, 'aq_base', obj).catalogs
	    try:
		if url not in catalogs:
		    catalogs.append(url)
		    buf = buf + 'fixed %s\n' % obj.absolute_url(1)
	    except:
		catalogs = [url]
	    obj.catalogs = catalogs
	except:
	    buf = buf + '<b>can\'t fix %s</b>\n' % self.getpath(item.data_record_id_)
    return buf
	    
# STX Document methods
# ---------------------


default_format="""<!--#var standard_html_header-->

<!--#var content fmt="structured-text"-->

<!--#var standard_html_footer-->"""

def addSTXDocument(self, id, title='', submit='', REQUEST={}):
    """ """
    dest=self.Destination()
    ob=self.STXDocument(default_format, __name__=id)
    REQUEST['date']=DateTime()
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.propertysheets.Basic.manage_changeProperties(REQUEST)
    dest._setObject(id, ob)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')
    

def manage_edit_ex(self, data, title, SUBMIT='Change',
                             dtpref_cols='50',
                             dtpref_rows='20',
                             REQUEST=None):
    """Override manage_edit"""
    self.unindex_object(REQUEST=REQUEST)
    method=self.__class__.inheritedAttribute('manage_edit')
    method(self, data, title, SUBMIT, dtpref_cols, dtpref_rows)
    self.index_object()
    if REQUEST:
        message="Content changed."
        return self.manage_main(self,REQUEST,manage_tabs_message=message)

def manage_upload_ex(self, file='', REQUEST=None):
    """Override manage_upload"""
    self.unindex_object(REQUEST=REQUEST)
    method=self.__class__.inheritedAttribute('manage_upload')
    method(self, file)
    self.index_object()
    if REQUEST:
        message="Content changed."
        return self.manage_main(self,REQUEST,manage_tabs_message=message)

def STXDocument_text_content(self):
    """Return the text content of the object."""
    # return the actual stx content...
    return self.content + ' ' + self.title



# HTML Document methods
# ---------------------

def addHTMLDocument(self, id, title='', file='', submit='', REQUEST={}):
    """ """
    dest=self.Destination()
    ob=self.HTMLDocument(file, __name__=id)
    REQUEST['date']=DateTime()
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    dest._setObject(id, ob)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')

def HTMLDocument_text_content(self):
    """Return the text content of the object."""
    return self.read()




# NewsItem methods
# ----------------

def NewsItem_text_content(self):
    """Return the text content of the object."""
    return self.text + ' ' + self.title


# Link methods
# ------------

def Link_text_content(self):
    """Return text description of a link."""
    return self.description + ' ' + self.title

# How-To methods
# --------------

def HowTo_text_content(self):
    """Return text content of a How-To."""
    return self.content + ' ' + self.title

# Tip methods
# -----------

def Tip_text_content(self):
    """Return text content of a tip"""
    return self.tip + self.details

# Case Study methods
# ------------------

def CaseStudy_text_content(self):
    """Return composite of major sections for indexing."""
    return self.case_study_summary + '\n' + \
           self.facts + '\n' + \
           self.problem + '\n' + \
           self.solution + '\n' + \
           self.external_url


# Software methods
# ----------------

def Software_text_content(self):
    """Return text content of a Software object."""
    return self.description + ' ' + self.title


def findAllMemberNames(self):
    """ """
    # XXX This should go up the folder tree...
    allusers=self.acl_users.getUsers()
    names=[]
    for user in allusers:
        if user.has_role('Member'):
            names.append(user.getUserName())
    return names



def foo(self):
    t = []
    obj = self
    count = 0
    while 1:
        if hasattr(obj, 'aq_parent'):
            t.append(`obj`)
            obj = obj.aq_parent
        else:
            break
        count = count + 1
        if count > 10:
            t.append("!!")
            break
    return "<h3>Self gots .%s.</h3>" % string.join(t, ', ')

def getOwners(self, join=string.join):
    parent = self.aq_parent             # XXX Workaround
    parent.aq_acquire('__ac_local_roles__')
    dict = parent.__ac_local_roles__ or {} # XXX Workaround
    list=[]
    for key, val in dict.items():
        if 'Owner' in val:
            list.append(key)
    return join(list, ', ')



def reindex_all(self, obj=None):
    """ """
    if obj is None: obj=self
    if hasattr(aq_base(obj), 'index_object'):
        obj.index_object()
    if hasattr(aq_base(obj), 'objectValues'):
        sub=obj.objectValues()
        for item in obj.objectValues():
            reindex_all(self, item)
    return 'done!'
               
