import sys, os, string, time, random, urllib
from DateTime import DateTime

import pdb


# Findable object methods. These are methods common to objects
# which subclass Findable, which provide implementations for
# obtaining certain metadata (such as creator), as well as
# common methods that handle the details of indexing and
# unindexing Findable objects.


def manage_afterAdd(self, item, container):
    # The first 'if' is required because string.split will return '' if given
    # an empty string and a seperator.  Why??
    if len(self.catalogs):
	for catname in self.catalogs:
	    self.index_object(self, catname)
    for object in self.objectValues():
        try: s=object._p_changed
        except: s=0
        object.manage_afterAdd(item, container)
        if s is None: object._p_deactivate()

def manage_afterClone(self, item):
    if len(self.catalogs):
	for catname in self.catalogs:
	    self.index_object(self, catname)
    for object in self.objectValues():
        try: s=object._p_changed
        except: s=0
        object.manage_afterClone(item)
        if s is None: object._p_deactivate()

def manage_beforeDelete(self, item, container):
    self.unindex_object(self)
    for object in self.objectValues():
        try: s=object._p_changed
        except: s=0
        object.manage_beforeDelete(item, container)
        if s is None: object._p_deactivate()



def creator(self):
    """Return a sequence of user names who have the local
       Owner role on an object. The name creator is used
       for this method to conform to Dublin Core."""
    #parent=self.aq_parent
    #roles=parent.aq_acquire('__ac_local_roles__')
    #dict=roles or {} #parent.__ac_local_roles__ or {}
    #items=[]
    #for key, val in dict.items():
    #    if 'Owner' in val:
    #        items.append(key)
    #return string.join(items, ', ')

    users=[]
    for user, roles in self.get_local_roles():
        if 'Owner' in roles:
            users.append(user)
    return string.join(users, ', ')

def url(self, ftype=urllib.splittype, fhost=urllib.splithost):
    """Return a SCRIPT_NAME-based url for an object."""
    if hasattr(self, 'DestinationURL') and \
       callable(self.DestinationURL):
        url='%s/%s' % (self.DestinationURL(), self.id)
    else: url=self.absolute_url()
    type, uri=ftype(url)
    host, uri=fhost(uri)
    script_name=self.REQUEST['SCRIPT_NAME']
    if script_name:
        uri=filter(None, string.split(uri, script_name))[0]
    uri=uri or '/'
    if uri[0]=='/': uri=uri[1:]
    return uri

def summary(self, num=200):
    """Return a summary of the text content of the object."""
    if not hasattr(self, 'text_content'):
        return ''
    attr=getattr(self, 'text_content')
    if callable(attr):
        text=attr()
    else: text=attr
    n=min(num, len(text))
    return text[:n]

def getIndex(self, REQUEST=None):
    # return the index to index an object in.
    # this is used to index Members's objects in a different
    # index than Contributors's objects.
    if REQUEST is None:
        REQUEST=self.REQUEST        
    if REQUEST.AUTHENTICATED_USER.has_role('Contributor'):
        return self.SiteIndex
    return self.UnreviewedIndex  

def index_object(self, catalog=None):
    """A common method to allow Findables to index themselves."""
    if catalog == None:
	catalog = self.getIndex().absolute_url(1)
    catobj = getattr(self, catalog)
    while catalog in self.catalogs: self.unindex_object(self, catalog)
    catobj.catalog_object(self, self.url())
    catalogs = self.catalogs
    catalogs.append(catalog)
    self.catalogs = catalogs

def unindex_object(self, catalog=None):
    """A common method to allow Findables to unindex themselves."""
    if catalog == None:
	for catname in self.catalogs:
	    self.unindex_object(self, catname)
	return
    catobj = getattr(self, catalog)
    catobj.uncatalog_object(self.url())
    catalogs = self.catalogs
    if type(catalogs) != type([]): catalogs = []
    while catalog in catalogs: catalogs.remove(catalog)
    self.catalogs = catalogs

def date(self):
    """
    Modification date.
    """
    return self.bobobase_modification_time()




# STX Document methods
# ---------------------


default_format="""<!--#var standard_html_header-->

<!--#var content fmt="structured-text"-->

<!--#var standard_html_footer-->"""

def addSTXDocument(self, id, title='', submit='', REQUEST={}):
    """ """
    dest=self.Destination()
    ob=self.STXDocument(default_format, __name__=id)
    REQUEST['date']=DateTime()
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    ob.propertysheets.Basic.manage_changeProperties(REQUEST)
    dest._setObject(id, ob)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')
    

def manage_edit_ex(self, data, title, SUBMIT='Change',
                             dtpref_cols='50',
                             dtpref_rows='20',
                             REQUEST=None):
    """Override manage_edit"""
    self.unindex_object()
    method=self.__class__.inheritedAttribute('manage_edit')
    method(self, data, title, SUBMIT, dtpref_cols, dtpref_rows)
    self.index_object()
    if REQUEST:
        message="Content changed."
        return self.manage_main(self,REQUEST,manage_tabs_message=message)

def manage_upload_ex(self, file='', REQUEST=None):
    """Override manage_upload"""
    self.unindex_object()
    method=self.__class__.inheritedAttribute('manage_upload')
    method(self, file)
    self.index_object()
    if REQUEST:
        message="Content changed."
        return self.manage_main(self,REQUEST,manage_tabs_message=message)

def STXDocument_text_content(self):
    """Return the text content of the object."""
    # return the actual stx content...
    return self.content



# HTML Document methods
# ---------------------

def addHTMLDocument(self, id, title='', file='', submit='', REQUEST={}):
    """ """
    dest=self.Destination()
    ob=self.HTMLDocument(file, __name__=id)
    REQUEST['date']=DateTime()
    ob.propertysheets.Findables.manage_changeProperties(REQUEST)
    dest._setObject(id, ob)
    if REQUEST:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        if submit==" Add and Edit ":
            url="%s/%s" % (url, urllib.quote(id))
        REQUEST.RESPONSE.redirect(url+'/manage_workspace')

def HTMLDocument_text_content(self):
    """Return the text content of the object."""
    return self.read()




# NewsItem methods
# ----------------

def NewsItem_text_content(self):
    """Return the text content of the object."""
    return self.text


# Link methods
# ------------

def Link_text_content(self):
    """Return text description of a link."""
    return self.description

# How-To methods
# --------------

def HowTo_text_content(self):
    """Return text content of a How-To."""
    return self.content


# Case Study methods
# ------------------

def CaseStudy_text_content(self):
    """Return composite of major sections for indexing."""
    return self.case_study_summary + '\n' + \
           self.facts + '\n' + \
           self.problem + '\n' + \
           self.solution + '\n' + \
           self.external_url


# Software methods
# ----------------

def Software_text_content(self):
    """Return text content of a Software object."""
    return self.description


def findAllMemberNames(self):
    """ """
    # XXX This should go up the folder tree...
    allusers=self.acl_users.getUsers()
    names=[]
    for user in allusers:
        if user.has_role('Member'):
            names.append(user.getUserName())
    return names



def foo(self):
    t = []
    obj = self
    count = 0
    while 1:
        if hasattr(obj, 'aq_parent'):
            t.append(`obj`)
            obj = obj.aq_parent
        else:
            break
        count = count + 1
        if count > 10:
            t.append("!!")
            break
    return "<h3>Self gots .%s.</h3>" % string.join(t, ', ')

def getOwners(self, join=string.join):
    parent = self.aq_parent             # XXX Workaround
    parent.aq_acquire('__ac_local_roles__')
    dict = parent.__ac_local_roles__ or {} # XXX Workaround
    list=[]
    for key, val in dict.items():
        if 'Owner' in val:
            list.append(key)
    return join(list, ', ')



def reindex_all(self, obj=None):
    """ """
    if obj is None: obj=self
    if hasattr(aq_base(obj), 'index_object'):
        obj.index_object()
    if hasattr(aq_base(obj), 'objectValues'):
        sub=obj.objectValues()
        for item in obj.objectValues():
            reindex_all(self, item)
    return 'done!'
               
    
