##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

"""Enhanced document object base classes"""
__version__='$Revision: 1.1 $'[11:-2]

from ComputedAttribute import ComputedAttribute
from DocumentTemplate.DT_String import String
from OFS.DTMLDocument import DTMLDocument
from OFS.DTMLMethod import DTMLMethod
from ExtensionClass import Base
import Globals




class DocumentHooks(Base):
    """ """

    def __get_name__(self):
        return getattr(self, '__name__')

    id=ComputedAttribute(__get_name__)

    def manage_edit(self,data,title,SUBMIT='Change',dtpref_cols='50',
                    dtpref_rows='20',REQUEST=None):
        """ """
        self.onEditBegin()
        r=DTMLMethod.manage_edit(self, data, title, SUBMIT=SUBMIT,
                                 dtpref_cols=dtpref_cols,
                                 dtpref_rows=dtpref_rows,
                                 REQUEST=REQUEST)
        self.onEditComplete()
        return r

    def manage_upload(self,file='', REQUEST=None):
        """ """
        self.onEditBegin()
        r=DTMLMethod.manage_upload(self, file, REQUEST)
        self.onEditComplete()
        return r

    def PUT(self, REQUEST, RESPONSE):
        """ """
        self.onEditBegin()
        r=DTMLMethod.PUT(self, REQUEST, RESPONSE)
        self.onEditComplete()
        return r

    def onEditBegin(self):
        """ """
        pass

    def onEditComplete(self):
        """ """
        pass


class HTMLDocument(DocumentHooks, DTMLDocument):
    """ """

    _state_name={'raw':1, 'globals':1, '__name__':1, '_vars':1,
                 '_proxy_roles':1,
                 'title':1,
                 'subject':1,
                 'description':1,
                 'date':1,
                 'content':1,
                 'reviewed':1,
                 }.has_key


class HTMLMethod(DocumentHooks, DTMLMethod):
    """ """
    _state_name={'raw':1, 'globals':1, '__name__':1, '_vars':1,
                 '_proxy_roles':1,
                 'title':1,
                 'subject':1,
                 'description':1,
                 'date':1,
                 'content':1,
                 'reviewed':1,
                 }.has_key



Globals.default__class_init__(HTMLDocument)
Globals.default__class_init__(HTMLMethod)
