# This module implements various external methods used
# by our Membership and registration objects.


import sys, os, string, time, random
from DateTime import DateTime




# Registration methods
# --------------------


def added_props(self):
    """ """
    stdprops=('name','email','last_visit','prev_visit','full_name','company')
    c=self.Control_Panel.Products.ZopeSite.MemberFolder
    c=c.propertysheets.methods._getOb('Member')
    ps=c.propertysheets.common.CommonProperties
    ids=ps.propertyIds()
    set=[]
    for id in ids:
        if not (id in stdprops):
            set.append(id)
    return set

chars=string.letters+string.digits
def gen_password(choose=random.choice, chars=chars, join=string.join):
    result=[]
    for n in range(8):
        result.append(choose(chars))
    return join(result, '')
    

def register(self, username='', fullname='', company='', email='',
             REQUEST=None):
    """ """
    register_html=getattr(self, 'register.html')
    if not username or not email:
        return register_html(self, REQUEST,
               error='You must enter a value for Name and a valid Email ' \
                     'Address.')

    user=self.acl_users.getUser(username)
    if user is not None:
        return register_html(self, REQUEST,
               error='The login name you selected is already in use. Please ' \
                     'choose another.')
    password=gen_password()

    # Add the member

    self.acl_users.addUser(username, password, ['Member'], [])

    user=self.acl_users.getUser(username)
    for ps in user.propertysheets:
        ps.manage_changeProperties(REQUEST)
    
    # Here we add a new Folder for this user in Members,
    # giving the user the local role 'Owner' in his Folder.
    members=self.Members
    members.manage_addFolder(username)
    folder=getattr(members, username)
    if REQUEST:
        name=REQUEST['AUTHENTICATED_USER'].getUserName()
        folder.manage_delLocalRoles([name])
    folder.manage_setLocalRoles(username, ['Owner'])
    
    # Generate email notification
    self.notify(self, REQUEST, password=password)

    return getattr(self, 'success.html')(self, REQUEST)


def updateMember(self, REQUEST):
    """ """
    user=REQUEST['AUTHENTICATED_USER']
    name=user.getUserName()
    if hasattr(user, 'propertysheets'):
        for ps in user.propertysheets:
            ps.manage_changeProperties(REQUEST)
        return self.index_html(self, REQUEST,
                               message='Your changes have been saved.')
    else:
        return self.index_html(self, REQUEST,
                               message='Cannot set non-member %s' % user)

# MemberFolder methods
# --------------------


def fixup_user(user):
    if hasattr(user, 'last_visit'):
        if not user.last_visit.isCurrentDay():
            user.prev_visit=user.last_visit
            user.last_visit=DateTime().earliestTime()
    return user

def addMemberFolder(self, REQUEST=None):
    if hasattr(self.aq_base, 'acl_users'):
        return MessageDialog(
               title  ='Item Exists',
               message='This object already contains a User Folder',
               action ='%s/manage_main' % REQUEST['URL1'])
    dest=self.Destination()
    ob=self.MemberFolder() #'acl_users', REQUEST)
    dest._setObject('acl_users', ob)
    dest.__allow_groups__=dest.acl_users
    if REQUEST: return dest.manage_main(dest, REQUEST, update_menu=1)


def addUser(self, name, password, roles, domains, REQUEST=None):
    """ """
#    zclass=self.Control_Panel.Products.ZopeSite.MemberFolder.Member._zclass_
    user=self.Member(name, password, roles, domains)
    user.id=name
    self.data[name]=user    
    if REQUEST is not None:
        return self.manage_main(self, REQUEST=REQUEST)

def getUser(self, name):
    """ """
    if self.data.has_key(name):
        user=self.data[name].__of__(self)
        user=fixup_user(user)
        return user
    return None

def changeUser_Form(self, name, REQUEST=None):
    """ """
    user=self.data[name].__of__(self)
    return self.changeUserForm(self, REQUEST=REQUEST, user=user,
                               password=user._getPassword())

def changeUser(self, name, password, roles, domains, REQUEST=None):
    """ """
    user=self.data[name]
    user._pw_=password
    user.roles=roles
    user.domains=domains
    if REQUEST is not None:
        return self.manage_main(self, REQUEST=REQUEST)

def changeUserPassword(self, name, password, domains, REQUEST=None):
    """ """
    user=self.data[name]
    user._pw_=password
    user.domains=domains
    if REQUEST is not None:
        return self.manage_main(self, REQUEST=REQUEST)

        
def delUser(self, names, REQUEST=None):
    """ """
    # Delete and clean up after a user
    members=self.Members
    for name in names:
        if self.data.has_key(name):
            del self.data[name]
        if hasattr(members.aq_base, name):
            members._delObject(name)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST=REQUEST)
