import sys, os, string, time, random
from DateTime import DateTime



def getOwners(self, join=string.join):
    dict=self.__ac_local_roles__ or {}
    list=[]
    for key, val in dict.items():
        if 'Owner' in val:
            list.append(key)
    return join(list, ', ')



def approveNewsItem(self, REQUEST=None):
    """ """
    for ps in self.propertysheets.values():
        ps.manage_changeProperties(REQUEST=REQUEST)
    # Add to catalog here...
    
    self.title=title


def ReturnFindableAttributes(self):
    """ Should be bound to an objects 'ZopeCatalogAttributes' method
    """
    fas = ()

    for x in self.__class__.__bases__:
        if hasattr(x, 'findableAttributes'):
            if x.findableAttributes:
                for i  in x.findableAttributes:
                    (n, a, t, i) = string.split(i)
                    fas.append({'name' : n, 'attr' : a, 'type' : t, 
                                'index' : i})

    if self.findableAttributes:
        for i in self.findableAttributes:
            (n, a, t, i) = string.split(i)
            fas.append({'name' : n, 'attr' : a, 'type' : t, 'index' : i})

    return fas



def DelObjects(self, ids, REQUEST):
    """ Deletes an list of objects from the catalog
    """
    urls = []

    for n in ids:
        urls.append(getattr(self, n).absolute_url())
    self.Catalog.manage_catalogRemove(urls=urls)

    self.manage_delObjects(ids)
    return self.manage_main(self, REQUEST)





# Registration methods
# --------------------

chars=string.letters+string.digits
def gen_password(choose=random.choice, chars=chars, join=string.join):
    result=[]
    for n in range(8):
        result.append(choose(chars))
    return join(result, '')
    

def register(self, username='', fullname='', company='', email='',
             REQUEST=None):
    """ """
    register_html=getattr(self, 'register.html')
    if not username or not email:
        return register_html(self, REQUEST,
               error='You must enter a value for Name and a valid Email ' \
                     'Address.')

    user=self.acl_users.getUser(username)
    if user is not None:
        return register_html(self, REQUEST,
               error='The login name you selected is already in use. Please ' \
                     'choose another.')
    password=gen_password()

    # Add the member
    self.acl_users.addUser(username, password, ['Member'], [])
    
    # Here we add a new Folder for this user in Members,
    # giving the user the local role 'Owner' in his Folder.
    members=self.Members
    members.manage_addFolder(username)
    folder=getattr(members, username)
    folder.manage_setLocalRoles(username, ['Owner'])    

    # Generate email notification
    self.notify(self, REQUEST, password=password)

    return getattr(self, 'success.html')(self, REQUEST)




# MemberFolder methods
# --------------------


def fixup_user(user):
    if hasattr(user, 'last_visit'):
        if not user.last_visit.isCurrentDay():
            user.last_visit=DateTime().earliestTime()
    return user

def addMemberFolder(self, REQUEST=None):
    if hasattr(self.aq_base, 'acl_users'):
        return MessageDialog(
               title  ='Item Exists',
               message='This object already contains a User Folder',
               action ='%s/manage_main' % REQUEST['URL1'])
    dest=self.Destination()
    __traceback_info__=(hasattr(dest.aq_base, 'acl_users'),)
    ob=self.MemberFolder('acl_users', REQUEST)
    dest.__allow_groups__=dest.acl_users
    if REQUEST: return dest.manage_main(dest, REQUEST, update_menu=1)


def addUser(self, name, password, roles, domains, REQUEST=None):
    """ """
    zclass=self.Control_Panel.Products.ZopeSite.MemberFolder.Member._zclass_
    user=zclass(name, password, roles, domains)
    user.id=name
    self.data[name]=user

    # Here we add a new Folder for this user in Members,
    # giving the user the local role 'Owner' in his Folder.
    members=self.Members
    members.manage_addFolder(name)
    folder=getattr(members, name)
    if REQUEST is not None:
        user=REQUEST.get('AUTHENTICATED_USER', None)
        if user is not None:
            folder.manage_delLocalRoles([user.getUserName()])
    folder.manage_setLocalRoles(name, ['Owner'])    
    
    if REQUEST is not None:
        return self.manage_main(self, REQUEST=REQUEST)

def getUser(self, name):
    """ """
    if self.data.has_key(name):
        user=self.data[name].__of__(self)
        user=fixup_user(user)
        return user
    return None

def changeUser_Form(self, name, REQUEST=None):
    """ """
    user=self.data[name].__of__(self)
    return self.changeUserForm(self, REQUEST=REQUEST, user=user,
                               password=user._getPassword())

def changeUser(self, name, password, roles, domains, REQUEST=None):
    """ """
    user=self.data[name]
    user.__=password
    user.roles=roles
    user.domains=domains
    if REQUEST is not None:
        return self.manage_main(self, REQUEST=REQUEST)
        
def delUser(self, names, REQUEST=None):
    """ """
    # Delete and clean up after a user
    members=self.Members
    for name in names:
        if self.data.has_key(name):
            del self.data[name]
        if hasattr(members.aq_base, name):
            members._delObject(name)
            if REQUEST is not None:
                return self.manage_main(self, REQUEST=REQUEST)
